/*
* cutadapt :
* Imputs : fastq files
* Output : fastq files
*/

/*                     Small RNA-seq Illumina adaptor removal NEXTflex Small RNA Seq Kit v3                            */

/*
* for paired-end data
*/

params.fastq = "$baseDir/data/fastq/*_R{1,2}_001.fastq.gz"

log.info "fastq files : ${params.fastq}"

Channel
  .fromFilePairs( params.fastq )
  .ifEmpty { error "Cannot find any fastq files matching: ${params.fastq}" }
  .set { fastq_files }

process adaptor_removal {
  tag "$pair_id"
  publishDir "results/fastq/adaptor_removal/", mode: 'copy'

  input:
  set pair_id, file(reads) from fastq_files

  output:
  set pair_id, "*_cut_R{1,2}_001.fastq.gz" into fastq_files_cut

  script:
  """
  cutadapt -a TGGAATTCTCGGGTGCCAAGG -A GTTCAGAGTTCTACAGTCCGACGATC \
  -o ${pair_id}_cut_R1.fastq.gz -p ${pair_id}_cut_R2.fastq.gz \
  ${reads[0]} ${reads[1]} > ${pair_id}_report.txt
  """
}
